# coding: utf-8

from __future__ import absolute_import
from six import iteritems
from six.moves import http_client as httplib


def singleton(cls, *args, **kw):
    instances = {}

    def _singleton():
        if cls not in instances:
            instances[cls] = cls(*args, **kw)
        return instances[cls]
    return _singleton


@singleton
class Configuration(object):
    def __init__(self):
        """
        Constructor
        """
        # Default Base url
        self.host = "https://api.staging.valdit.com/api/v1"
        # Default api client
        self.api_client = None
        # Temp file folder for downloading files
        self.temp_folder_path = None

        # access for OAuth - mandatory
        self.access_token = ""
        self.oauth_user_id = False
        self.oauth_user_secret = False
        self.oauth_scope = False
        
        # access for OAuth - optional
        self.endpoint_type = "production"
