# coding: utf-8

"""
    Valdit Dutch Addresses API

    An API for Geocoding and Validating Dutch Postal Address.

    OpenAPI spec version: 1.0.0
    Contact: api@valdit.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class InlineResponse200DataAddress(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, address_type=None, street=None, house_number=None, house_number_suffix=None, postal_code=None, city=None, municipality=None, province=None, country_code=None, formatted_address=None, bag_number_designation_id=None, bag_addressable_object_id=None, geolocation=None, rd_coordinates=None):
        """
        InlineResponse200DataAddress - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'address_type': 'str',
            'street': 'str',
            'house_number': 'int',
            'house_number_suffix': 'str',
            'postal_code': 'str',
            'city': 'str',
            'municipality': 'str',
            'province': 'str',
            'country_code': 'str',
            'formatted_address': 'str',
            'bag_number_designation_id': 'str',
            'bag_addressable_object_id': 'str',
            'geolocation': 'InlineResponse200DataAddressGeolocation',
            'rd_coordinates': 'InlineResponse200DataAddressRdCoordinates'
        }

        self.attribute_map = {
            'address_type': 'addressType',
            'street': 'street',
            'house_number': 'houseNumber',
            'house_number_suffix': 'houseNumberSuffix',
            'postal_code': 'postalCode',
            'city': 'city',
            'municipality': 'municipality',
            'province': 'province',
            'country_code': 'countryCode',
            'formatted_address': 'formattedAddress',
            'bag_number_designation_id': 'bagNumberDesignationId',
            'bag_addressable_object_id': 'bagAddressableObjectId',
            'geolocation': 'geolocation',
            'rd_coordinates': 'rdCoordinates'
        }

        self._address_type = address_type
        self._street = street
        self._house_number = house_number
        self._house_number_suffix = house_number_suffix
        self._postal_code = postal_code
        self._city = city
        self._municipality = municipality
        self._province = province
        self._country_code = country_code
        self._formatted_address = formatted_address
        self._bag_number_designation_id = bag_number_designation_id
        self._bag_addressable_object_id = bag_addressable_object_id
        self._geolocation = geolocation
        self._rd_coordinates = rd_coordinates

    @property
    def address_type(self):
        """
        Gets the address_type of this InlineResponse200DataAddress.
        Type of Address returned in the response

        :return: The address_type of this InlineResponse200DataAddress.
        :rtype: str
        """
        return self._address_type

    @address_type.setter
    def address_type(self, address_type):
        """
        Sets the address_type of this InlineResponse200DataAddress.
        Type of Address returned in the response

        :param address_type: The address_type of this InlineResponse200DataAddress.
        :type: str
        """
        allowed_values = ["address", "street", "city", "municipality", "po_box"]
        if address_type not in allowed_values:
            raise ValueError(
                "Invalid value for `address_type` ({0}), must be one of {1}"
                .format(address_type, allowed_values)
            )

        self._address_type = address_type

    @property
    def street(self):
        """
        Gets the street of this InlineResponse200DataAddress.
        Name of street or route

        :return: The street of this InlineResponse200DataAddress.
        :rtype: str
        """
        return self._street

    @street.setter
    def street(self, street):
        """
        Sets the street of this InlineResponse200DataAddress.
        Name of street or route

        :param street: The street of this InlineResponse200DataAddress.
        :type: str
        """

        self._street = street

    @property
    def house_number(self):
        """
        Gets the house_number of this InlineResponse200DataAddress.
        Housenumber

        :return: The house_number of this InlineResponse200DataAddress.
        :rtype: int
        """
        return self._house_number

    @house_number.setter
    def house_number(self, house_number):
        """
        Sets the house_number of this InlineResponse200DataAddress.
        Housenumber

        :param house_number: The house_number of this InlineResponse200DataAddress.
        :type: int
        """

        self._house_number = house_number

    @property
    def house_number_suffix(self):
        """
        Gets the house_number_suffix of this InlineResponse200DataAddress.
        Suffix to the Housenumber

        :return: The house_number_suffix of this InlineResponse200DataAddress.
        :rtype: str
        """
        return self._house_number_suffix

    @house_number_suffix.setter
    def house_number_suffix(self, house_number_suffix):
        """
        Sets the house_number_suffix of this InlineResponse200DataAddress.
        Suffix to the Housenumber

        :param house_number_suffix: The house_number_suffix of this InlineResponse200DataAddress.
        :type: str
        """

        self._house_number_suffix = house_number_suffix

    @property
    def postal_code(self):
        """
        Gets the postal_code of this InlineResponse200DataAddress.
        National postal code as used for postal mail

        :return: The postal_code of this InlineResponse200DataAddress.
        :rtype: str
        """
        return self._postal_code

    @postal_code.setter
    def postal_code(self, postal_code):
        """
        Sets the postal_code of this InlineResponse200DataAddress.
        National postal code as used for postal mail

        :param postal_code: The postal_code of this InlineResponse200DataAddress.
        :type: str
        """

        self._postal_code = postal_code

    @property
    def city(self):
        """
        Gets the city of this InlineResponse200DataAddress.
        Name of the City

        :return: The city of this InlineResponse200DataAddress.
        :rtype: str
        """
        return self._city

    @city.setter
    def city(self, city):
        """
        Sets the city of this InlineResponse200DataAddress.
        Name of the City

        :param city: The city of this InlineResponse200DataAddress.
        :type: str
        """

        self._city = city

    @property
    def municipality(self):
        """
        Gets the municipality of this InlineResponse200DataAddress.
        Name of the Municipality

        :return: The municipality of this InlineResponse200DataAddress.
        :rtype: str
        """
        return self._municipality

    @municipality.setter
    def municipality(self, municipality):
        """
        Sets the municipality of this InlineResponse200DataAddress.
        Name of the Municipality

        :param municipality: The municipality of this InlineResponse200DataAddress.
        :type: str
        """

        self._municipality = municipality

    @property
    def province(self):
        """
        Gets the province of this InlineResponse200DataAddress.
        Name of the Province

        :return: The province of this InlineResponse200DataAddress.
        :rtype: str
        """
        return self._province

    @province.setter
    def province(self, province):
        """
        Sets the province of this InlineResponse200DataAddress.
        Name of the Province

        :param province: The province of this InlineResponse200DataAddress.
        :type: str
        """

        self._province = province

    @property
    def country_code(self):
        """
        Gets the country_code of this InlineResponse200DataAddress.
        ISO 3166-1 2-letter country code

        :return: The country_code of this InlineResponse200DataAddress.
        :rtype: str
        """
        return self._country_code

    @country_code.setter
    def country_code(self, country_code):
        """
        Sets the country_code of this InlineResponse200DataAddress.
        ISO 3166-1 2-letter country code

        :param country_code: The country_code of this InlineResponse200DataAddress.
        :type: str
        """
        if country_code is None:
            raise ValueError("Invalid value for `country_code`, must not be `None`")

        self._country_code = country_code

    @property
    def formatted_address(self):
        """
        Gets the formatted_address of this InlineResponse200DataAddress.
        Formatted address, mostly used for postal mail. Does not contain country

        :return: The formatted_address of this InlineResponse200DataAddress.
        :rtype: str
        """
        return self._formatted_address

    @formatted_address.setter
    def formatted_address(self, formatted_address):
        """
        Sets the formatted_address of this InlineResponse200DataAddress.
        Formatted address, mostly used for postal mail. Does not contain country

        :param formatted_address: The formatted_address of this InlineResponse200DataAddress.
        :type: str
        """

        self._formatted_address = formatted_address

    @property
    def bag_number_designation_id(self):
        """
        Gets the bag_number_designation_id of this InlineResponse200DataAddress.
        BAG Number Designation Identifier

        :return: The bag_number_designation_id of this InlineResponse200DataAddress.
        :rtype: str
        """
        return self._bag_number_designation_id

    @bag_number_designation_id.setter
    def bag_number_designation_id(self, bag_number_designation_id):
        """
        Sets the bag_number_designation_id of this InlineResponse200DataAddress.
        BAG Number Designation Identifier

        :param bag_number_designation_id: The bag_number_designation_id of this InlineResponse200DataAddress.
        :type: str
        """

        self._bag_number_designation_id = bag_number_designation_id

    @property
    def bag_addressable_object_id(self):
        """
        Gets the bag_addressable_object_id of this InlineResponse200DataAddress.
        BAG Addressable Object Identifier

        :return: The bag_addressable_object_id of this InlineResponse200DataAddress.
        :rtype: str
        """
        return self._bag_addressable_object_id

    @bag_addressable_object_id.setter
    def bag_addressable_object_id(self, bag_addressable_object_id):
        """
        Sets the bag_addressable_object_id of this InlineResponse200DataAddress.
        BAG Addressable Object Identifier

        :param bag_addressable_object_id: The bag_addressable_object_id of this InlineResponse200DataAddress.
        :type: str
        """

        self._bag_addressable_object_id = bag_addressable_object_id

    @property
    def geolocation(self):
        """
        Gets the geolocation of this InlineResponse200DataAddress.

        :return: The geolocation of this InlineResponse200DataAddress.
        :rtype: InlineResponse200DataAddressGeolocation
        """
        return self._geolocation

    @geolocation.setter
    def geolocation(self, geolocation):
        """
        Sets the geolocation of this InlineResponse200DataAddress.

        :param geolocation: The geolocation of this InlineResponse200DataAddress.
        :type: InlineResponse200DataAddressGeolocation
        """

        self._geolocation = geolocation

    @property
    def rd_coordinates(self):
        """
        Gets the rd_coordinates of this InlineResponse200DataAddress.

        :return: The rd_coordinates of this InlineResponse200DataAddress.
        :rtype: InlineResponse200DataAddressRdCoordinates
        """
        return self._rd_coordinates

    @rd_coordinates.setter
    def rd_coordinates(self, rd_coordinates):
        """
        Sets the rd_coordinates of this InlineResponse200DataAddress.

        :param rd_coordinates: The rd_coordinates of this InlineResponse200DataAddress.
        :type: InlineResponse200DataAddressRdCoordinates
        """

        self._rd_coordinates = rd_coordinates

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, InlineResponse200DataAddress):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
